#!/bin/sh
#===============================================================================
#
#  S70ntpd.sh
#
#  Copyright (C) 2008 by Digi International Inc.
#  All rights reserved.
#
#  This program is free software; you can redistribute it and/or modify it
#  under the terms of the GNU General Public License version 2 as published by
#  the Free Software Foundation.
#
#
#  !Revision:    $Revision: 1.6 $:
#  !Description: ntp daemon bootscript
#
#===============================================================================

daemon="ntpd"
cfgfile="/tmp/mnt/UserFS/pvkitadsl/config/ntpd.conf"
daemon_options="-s -f ${cfgfile}"
pidfile="/var/run/ntpd.pid"

[ -x "$(which ${daemon})" ] || exit 0
[ -f "${cfgfile}" ] || exit 0

# We need /var/empty/ntp to work properly
[ -d /var/empty/ntp ] || install -m 0755 -o 0 -g 0 -d /var/empty/ntp

start() {
	[ -z "${quietboot}" ] && echo -n "Starting ntpd: "
	start-stop-daemon -S -b -q -x ${daemon} -- ${daemon_options}
	[ -z "${quietboot}" ] && echo "OK"
}

stop() {
	echo -n "Stopping ntpd: "
	start-stop-daemon -K -o -q -n ${daemon}
	echo "OK"
}

restart() {
	stop
	sleep 1
	start
}

case "$1" in
start)
	start
	;;
stop)
	stop
	;;
restart|reload)
	restart
	;;
*)
	echo "Usage: $0 {start|stop|restart}"
	exit 1
esac

exit $?
