function getel(id) {  return document.getElementById(id); }

function jlog(lev, msg) {
    var e = getel('id_logbox');
    if (e)  e.value = (msg + "\n") + e.value; 
}

function jtrim(s) { return s.replace(/^\s\s*/, '').replace(/\s\s*$/, ''); }

function strip_html(html, keepbr) {
   var tmp = document.createElement("DIV");   
   html = html.replace(/<head>.*<\/head>/gi,'');
   if (! keepbr) html = html.replace(/<br\/?>/gi, "\n");
   html = html.replace(/<\/p>/gi,"\n");
   html = html.replace(/<\/h.*>/gi,"\n");
   html = html.replace(/<(?:.|\s)*?>/g, "");
   return html;
}


function fmtDate( fmt, adate ) {
    var yyyy = adate.getFullYear();
    var mm = ('' + (adate.getMonth() + 1 + 100)).substring(1);
    var dd = ('' + (adate.getDate()  + 100)).substring(1);
    var hh = ('' + (adate.getHours()  + 100)).substring(1);
    var nn = ('' + (adate.getMinutes()  + 100)).substring(1);
    var ss = ('' + (adate.getSeconds()  + 100)).substring(1);
    fmt = fmt.replace( /yyyy/, yyyy );
    fmt = fmt.replace( /mm/, mm );
    fmt = fmt.replace( /dd/, dd );
    fmt = fmt.replace( /hh/, hh );
    fmt = fmt.replace( /nn/, nn );
    fmt = fmt.replace( /ss/, ss );
    return fmt;
}


/* ==== d2h() =============================== */
    // decimal to hexadecimal conversion    
    function d2h (d, bit) {
        var hD="0123456789abcdef";
        var hbit = d & 0x80000000;
        d = d & 0x7fffffff;
        var h = hD.substr(d&15,1);
        while(d>15) {
            d>>=4;
            if (hbit) {
                d |= 0x08000000;
                hbit = 0;
            }
            h=hD.substr(d&15,1)+h;
        }
        if (bit) {
            var p = 2;
            switch(bit) {
            case 16 : p = 4; break;
            case 24 : p = 6; break;
            case 32 : p = 8; break;
            }
            h = this.padl( h, p, '0' );
        }
        return h;
    }
    
    
    function h2d(s) { return parseInt(s,16); }


function JLibAjax() {
    // readyState
    var AJST_UNKNOWN = 0;
    var AJST_LOADING = 1;
    var AJST_LOADED  = 2;
    var AJST_INTERACTIVE  = 3;
    var AJST_COMPLETE  = 4;
    
    // status
    var AJST_OK = 200;
   
    var request = null;
    
    this.getText = function() { 
        var req = this.request;
        return (req == null)? '' : req.responseText;
    }
    
    this.isError = function() {
        var req = this.request;
        return (req == null || req.readyState != 4 || req.status != 200);
    }
    
/* Wrapper function for constructing a request object.
 Parameters:
  reqType: The HTTP request type, such as GET or POST.
  url: The URL of the server program.
  asynch: Whether to send the request asynchronously or not.
  respHandle: The name of the function that will handle the response.
  Any fifth parameters, represented as arguments[4], are the data a
  POST request is designed to send. */
 this.httpRequest = function(reqType,url,asynch,respHandle){
    //Mozilla-based browsers
        
    if (! this.request) {    
        if(window.XMLHttpRequest){
            this.request = new XMLHttpRequest(  );
        } else if (window.ActiveXObject){
		try {
			this.request=new ActiveXObject("Msxml2.XMLHTTP.6.0");
		} catch( err ) { }
            if (! this.request){
		try {
			this.request=new ActiveXObject("Msxml2.XMLHTTP.3.0");
		} catch( err ) { }			
            }
            if (! this.request){
		try {
			this.request=new ActiveXObject("Msxml2.XMLHTTP");
		} catch( err ) { }
            }
            if (! this.request){
                this.request=new ActiveXObject("Microsoft.XMLHTTP");
            }
        }
    }
    
    //very unlikely, but we test for a null request
    //if neither ActiveXObject was initialized
    if(this.request) {
        //if the reqType parameter is POST, then the
        //5th argument to the function is the POSTed data
        if(reqType.toLowerCase(  ) != "post") {
            this.initReq(reqType,url,asynch,respHandle);
        }  else {
            //the POSTed data
            var args = arguments[4];
            if(args != null && args.length > 0){
                this.initReq(reqType,url,asynch,respHandle,args);
            }
        }
    } else {
        alert("Your browser does not permit the use of all "+
              "of this application's features!");
    }
}

/* Initialize a request object that is already constructed */
    this.initReq = function(reqType,url,bool,respHandle){
    try{
        /* Specify the function that will handle the HTTP response */
        this.request.open(reqType,url,bool);
        this.request.onreadystatechange=respHandle;
        //if the reqType parameter is POST, then the
        //5th argument to the function is the POSTed data
        if(reqType.toLowerCase(  ) == "post") {
            this.request.setRequestHeader("Content-Type",
                    "application/x-www-form-urlencoded; charset=UTF-8");
//            this.request.setRequestHeader("Content-Type",
//                    "text/plain");
            this.request.send(arguments[4]);
        }  else {
            this.request.send(null);
        }

    } catch (errv) {
        jlog('E',
        "The application cannot contact "+
        "the server at the moment. "+
        "Please try again in a few seconds. "+
        "Error detail: "+errv.message);
    }
}

} // ---- JLibAjax()


function parseUri (str) {
	var	o   = parseUri.options,
		m   = o.parser[o.strictMode ? "strict" : "loose"].exec(str),
		uri = {},
		i   = 14;

	while (i--) uri[o.key[i]] = m[i] || "";

	uri[o.q.name] = {};
	uri[o.key[12]].replace(o.q.parser, function ($0, $1, $2) {
		if ($1) uri[o.q.name][$1] = $2;
	});

	return uri;
};

parseUri.options = {
	strictMode: false,
	key: ["source","protocol","authority","userInfo","user","password","host","port","relative","path","directory","file","query","anchor"],
	q:   {
		name:   "queryKey",
		parser: /(?:^|&)([^&=]*)=?([^&]*)/g
	},
	parser: {
		strict: /^(?:([^:\/?#]+):)?(?:\/\/((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?))?((((?:[^?#\/]*\/)*)([^?#]*))(?:\?([^#]*))?(?:#(.*))?)/,
		loose:  /^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/)?((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/
	}
};



function qdate(n, dd) {
    getel('idFLD_DD'+n).value = dd.getDate();
    getel('idFLD_MM'+n).value = dd.getMonth() + 1;
    getel('idFLD_YY'+n).value = dd.getFullYear();

}

function tmRange(range) {

  var rr = getTimeRange(range, true, '1111');
  qdate(1, rr[0] );
  qdate(2, rr[2] );
  return false;

}


/*
        '*' => 'Quick time range',
        '1h' => 'Last hour',
        '12h' => 'Last 12h',
        '24h' => 'Last 24h',
        'today' => 'Today',
        'yesterday' => 'Yesterday',
        'week' => 'This week',
        '7days' => 'Last 7 days',
        'month' => 'This month',
        'lastmonth' => 'Last month',
        'year' => 'This year',
        'lastyear' => 'Last year'
*/        
function getTimeRange(s, noformat, forceflags) {
    // dd1 hh1 dd2 hh2
    var res = ['','','',''];
    var flags = "0000";
    d1 = new Date();
    d2 = new Date();
    switch (s) {
        case '30m' :
        case '1h' :
        case '12h' :
        case '24h' :
        case '7days' :
            var n; 
            if (s == '7days')
                n = 7*24;
            else if (s == '30m') 
                n = 0.5;
            else
                n = s.replace( /h/, '' ) * 1;
            d1.setTime( d1.getTime() - 1000*60*60*n );
            flags = "1100";
            break;
        case 'yesterday' :
        case 'today' :
            if (s == 'yesterday') d1.setTime( d1.getTime() - 1000*60*60*24 );
            d1.setHours(0);
            d1.setMinutes(0);
            d1.setSeconds(0);
            d1.setMilliseconds(0);
            flags = '1000';
            if (s == 'yesterday') { d2 = d1; flags = '1010'; }
            break;
        case 'week' :
            d1.setHours(0);
            d1.setMinutes(0);
            d1.setSeconds(0);
            d1.setMilliseconds(0);
            var wmap = [ 6,0,1,2,3,4,5 ];
            var w = wmap[d1.getDay()];
            d1.setTime( d1.getTime() - 1000*60*60*24*w ); // back w days
            flags = '1000';            
            break;
        case 'lastweek' :
            d1.setHours(0);
            d1.setMinutes(0);
            d1.setSeconds(0);
            d1.setMilliseconds(0);
            var wmap = [ 6,0,1,2,3,4,5 ];
            var w = wmap[d1.getDay()];
            d2.setTime( d1.getTime() - 1000*60*60*24*(w+1) ); // back w+1 days
            d1.setTime( d1.getTime() - 1000*60*60*24*(w+7) ); // back w+7 days
            flags = '1010';            
            break;
        case 'month' :
            d1.setDate(1);
            flags = '1000';            
            break;
        case 'lastmonth' :
            d1.setTime( d1.getTime() - 1000*60*60*24*d1.getDate() );
            d1.setDate(1);
            d2.setDate(1); // first of this month
            d2.setTime( d2.getTime() - 1000*60*60*24 ); // back 1 day
            flags = '1010';
            break;        
        case 'year' :
            d1.setDate(1);
            d1.setMonth(0);
            flags = '1000';
            break;
        case 'lastyear' :
            d1.setFullYear( d1.getFullYear() - 1 );
            d1.setDate(1);
            d1.setMonth(0);
            d2.setTime( d1.getTime() );
            d2.setDate(31);
            d2.setMonth(11);
            flags = '1010';
            break;            
            
        default :
            
            res = false;
    }
    if (forceflags) flags = forceflags;
    if (flags.charAt(0) == '1') res[0] = noformat? d1 : fmtDate( loc_date_fmt, d1 );
    if (flags.charAt(1) == '1') res[1] = noformat? d1 : fmtDate( "hh:nn", d1 );
    if (flags.charAt(2) == '1') res[2] = noformat? d2 : fmtDate( loc_date_fmt, d2 );
    if (flags.charAt(3) == '1') res[3] = noformat? d2 : fmtDate( "hh:nn", d2 );
    return res;
}

