
var ajax_wr;   // ajax sync commands
var ajax_poll; // ajax async commands
var master;    // mr. master

var DIGI_PORT = 83;

var ERR_NONE = 0;
var REBOOT_DELAY = 90;
var reboot_count;

var MIN_LOF = 600;  
var MAX_LOF = 600; 
var MIN_HIF = 60;
var MAX_HIF = 300; 
var MIN_WHI = 1;
var MAX_WHI = 20000;
var MIN_PNOM = 3;
var MAX_PNOM = 5000;
var MIN_MAXDLY = 0;
var MAX_MAXDLY = 600;
var PNOM_SHIFT = 500;

var SCALE_KW   = 100;
var SCALE_WHI  = 10;

var BIT_ALM_ONLINE = 4;
var NUM_ALARMS = 5;
var MAX_COUNTERS = 4;

var menu = [
'status',
'config',
'history',
'mant'
];
var idmenu = 'status';

var varlist = [];

var um_list = {
  "cn*.ptot" : "kW",
  "cn*.pnom" : "kW",
  "cn*.etot" : "kWh",
  "cn*.lof" : "min",
  "cn*.hif" : "min",
  "cn*.dbm" : "dBm",
  "sys.acqtime" : "min",
  "sys.inttime" : "min",
  "sys.prezzo" : "euro/kWh",
  "sys.co2"    : "kgCO2/kWh"
};

var numcounters = 0;

var verbose_result = false;

String.prototype.endsWith = function(str) {return (this.match(str+"$")==str)}

/**
 * Boot del rich client
 */
function client_boot() {
    ajax_wr = new JLibAjax();
    master = new JMaster();
    getel('id_logbox').value = '';
    getel('resultbox').value = '';
    getel('FLD_CMD').value = '';
    getel('FLD_PAR').value = '';
//    getel('FLD_DIGIIP').innerHTML = ''; //value = '';
    setupHistory();
    pollDevices();
}

function setupHistory() {
    var where = (navigator.appName == "Microsoft Internet Explorer") ? -1 : null;
    var dd1 = getel('idFLD_DD1');
    var dd2 = getel('idFLD_DD2');
    var mm1 = getel('idFLD_MM1');
    var mm2 = getel('idFLD_MM2');
    for (var i=1; i<=31; i++) {
        for (var k=1; k<=2; k++) {
            var newElem = document.createElement("option");
            newElem.text = '' + i;
            newElem.value = i;
            var cmb = (k == 1)? dd1 : dd2;
            cmb.add(newElem, where);
            }
    }
    for (var i=1; i<=12; i++) {
        for (var k=1; k<=2; k++) {
            var newElem = document.createElement("option");
            newElem.text = '' + i;
            newElem.value = i;
            var cmb = (k == 1)? mm1 : mm2;
            cmb.add(newElem, where);
            }
    }
    tmRange('today');
}

function switchDHCP(f) {    
    getel('pdhcp0').checked = !f;
    getel('pdhcp1').checked = f;
    for (var i = 0; i < 4; i++) {
        var el = getel('net'+i);
        el.style.display = !f? '' : 'none';
    }        
}

function showIP(ip,lab) {
    if (typeof ip == 'undefined' || ip == '') ip = '0.0.0.0';
    getel('' + lab).value = ip;
}

function getIP(lab) {
    var res = jtrim(getel('' + lab).value);
    return res;
}

function validIP(ip, fmask) {
  if (! ip.match(/^[1-9]([0-9]{0,2})\.([0-9]{0,3})\.([0-9]{0,3})\.([0-9]{0,3})$/)) return false;
  var arr = ip.split('.');
  if (arr.length != 4) return false;
  for (i = 0; i < 4; i++) {
    if (arr[i] < 0 || arr[i] > 255) return false;    
  }
  if (fmask) {
    var n = (arr[0] << 24) | (arr[1] << 16) | (arr[2] << 8) | (arr[3]);
    n = n.toString(2);
    if (n.match(/01/)) return false;
  } else {
    if (arr[0] == 0 || arr[3] == 0 || arr[0] == 255 || arr[3] == 255) return false;
  }
  return true;
}


function updateIP() {
  var dhcp = varlist['sys.dhcp'] * 1;
  switchDHCP(dhcp);
  var pars = ['ip', 'mask', 'gway', 'dns' ];
  var pv = [];
  for (var i=0; i<4; i++) {
    pv[0] = dhcp? '0.0.0.0' : varlist['sys.'+pars[i]];
    /*if (! dhcp)*/ showIP(pv[0], 'sys.' + pars[i]);
  }
}

function updateAlarmPower() {
  var alrpower = varlist['sys.alrpwr'] * 1;
  var cbAlrPwr = getel('sys.alrpwr_b');
  
  if (alrpower == 1) {
	cbAlrPwr.checked = true;
  } else {
	cbAlrPwr.checked = false;
  }
}

function rebooting() {
  var box = getel("resultbox");
  if (reboot_count == 0) {
    //window.location.href=window.location.href;
    window.location.reload();
  } else {
    box.value = "RIAVVIO SISTEMA IN CORSO\nLA PAGINA VERRA' AGGIORNATA AUTOMATICAMENTE FRA\n"   + reboot_count + " SECONDI ...\n";
    setTimeout("rebooting()",1000);  
  }
  reboot_count--;
}


function handleAlarms(key, value) {    
    var u = value =='?';
    for (var i = 0; i < NUM_ALARMS; i++) {
        var el = getel(key + i);
        if (! el) continue;
        var v = value & 1;
        var cn = u? 'alarm' : (v? 'alarm1' : 'alarm0');
        el.className = cn;
        value >>= 1;
    }
}

function downloadConfigFile() {
  var el = getel("fmdownloadconfig");
  var s = master.getURL();
  el.action=s;  
  el.submit();
}
function uploadConfigFile() {
  getel("uploadconfigbox").style.display = 'block';
  var el = getel("fmuploadconfig");
  var s = master.getURL();
  el.action=s;  
}

function fmtFloat(v, pad) {
  var s = '' + v;
  while (s.length <= pad) s = '0' + s;
  return s.substring(0,s.length-pad) + '.' + s.substring(s.length-pad,s.length);
}

function getHistory() {
    var dd1 = getel('idFLD_DD1').value * 1;
    var dd2 = getel('idFLD_DD2').value * 1;
    var mm1 = getel('idFLD_MM1').value * 1;
    var mm2 = getel('idFLD_MM2').value * 1;
    var yy1 = getel('idFLD_YY1').value * 1;
    var yy2 = getel('idFLD_YY2').value * 1;
    if (yy1 < 2011 || yy1 > 3000 || yy2 < 2011 || yy2 > 3000) {
        alert('Anno non valido');
        return;
    }
    var utc1 = Date.UTC(yy1,mm1-1,dd1,0,0,0,0) / 1000;
    var utc2 = Date.UTC(yy2,mm2-1,dd2,0,0,0,0) / 1000;
    getel('fdd1').value = utc1;
    getel('fdd2').value = utc2;
    getel('fcnt').value = getel('idFLD_HISTCNT').value * 1;
    getel('fmdownloadhistory').submit();
    
    
}

function isRegistered() { return varlist['sys.regist']*1 == 1; }

function get_um(key,um) {
  key = key.replace(/cn\d/,'cn*');
  if (um && um_list[key]) return ' ' + um_list[key];
  return '';
}

function displayVar(varname) {
  return displayVal(varname, varlist[varname], null, false);
}

/**
 * Stringa da visualizzare
 */
function displayVal(key, value, el, um) {

  if (key.endsWith('.on') || key.endsWith('.remon')) {
    if (el.className.indexOf('led')>=0) el.className = 'led' + ((value == 1)?1:0);
    return (value == 1)? 'ONLINE' : 'OFFLINE';  
  }

  if (value == '?') return '----';
  if (key.endsWith('.mac') > 0)
    return ''
              + value.substring(14,16)
        + ':' + value.substring(12,14)
        + ':' + value.substring(10,12)
        + ':' + value.substring(8,10)
        + ':' + value.substring(6,8)
        + ':' + value.substring(4,6)
        + ':' + value.substring(2,4)
        + ':' + value.substring(0,2) 

        ;

    var metakey = key.replace( /cn\d/, 'cn*' );

    switch (metakey) {

        case 'sys.cpass' :
            value = '';
            getel('sys.cpass2').value = '';
            break;

        case 'sys.nimp' : 
            if (value == '') value = 'ETH-Plant-' + varlist['sys.sn'];
            break;
    
        case 'cn*.lof' :
        case 'cn*.hif' :
        case 'sys.acqtime' :
        case 'sys.inttime' :
        case 'sys.maxdly' :
            return Math.floor(value / 60) + get_um(key,um);
            
        case 'cn*.init' :
            return (value*1)? 'SI' : 'NO';
                        
        case 'cn*.sig' :
            return '' + value + ' dBm';            

        case 'cn*.olds' :             
        case 'cn*.news' :             
            var d = new Date();
            if (value < 1311157572) return '--/--/---- --:--:--';
            d.setTime(value * 1 * 1000);    
            return '' + fmtDate('dd/mm/yyyy',d);

        case 'cn*.time' :             
        case 'sys.time' : {
            var d = new Date();
            if (value < 1311157572) return '--/--/---- --:--:--';
            d.setTime(value * 1 * 1000);    
            return '' + fmtDate('dd/mm/yyyy hh:nn:ss',d);
        }

        case 'cn*.ver' :
        case 'gw1.ver' :
        case 'sys.ver' :
            return h2d(value.substring(0,2)) + '.' + h2d(value.substring(2,4)) + '.' + h2d(value.substring(4,6));

        case 'sys.prezzo' :
        case 'sys.co2' :
            res = fmtFloat(value,3);
            return res + get_um(key,um);        

        case 'cn*.whi' : {
            res = fmtFloat(value,1);
            return res + get_um(key,um);
        }
        
        case 'cn*.ptot' :
        case 'cn*.etot' : {
            res = fmtFloat(value,2);
            return res + get_um(key,um);
        }
        
        case 'cn*.pmin' : {
            var whi = varlist[key.substring(0,3) + '.whi'];
            if (value == 0) return 0;
            return Math.floor( (whi/SCALE_WHI) * 3600 * 256 / value );
        }

        case 'sys.remerr' : {
            return strip_html(value, true);
        }
        
        case 'sys.regist' : {
        alert(value + ' ' + typeof value);
            
            return value;
        }
        
        case 'sys.sn' : {
            var f = isRegistered();
            getel('btregist').value = f? 'MODIFICA REGISTRAZIONE' : 'REGISTRA IMPIANTO';
            return value + '  ' + (f? '[REGISTRATO]' : '[NON REGISTRATO]');
        }
        
        case 'sys.currip' : {
            var arr = value.split('.');
          if (arr.length != 4 || arr[0] == 0 || arr[3] == 0) {
            alert("ATTENZIONE: i parametri di rete del sistema non sono correttamente configurati. Accedere al menu \"Utilit\" per cambiare la configurazione di rete");
            value = '--.--.--.--';          
            };
            return value;
        }
        
    }

  
  return value + get_um(key,um);
}

function fillElement(el, s) {
    if (el.tagName.toUpperCase() == 'INPUT') {
        el.value = s;
        return;
    }
    el.innerHTML = s;
        
}


function updateVar(key,value) {

    if (key == 'cn1.init' && value != '?' && value != '1') {
        alert('Contatore non inizializzato, necessario riavviare il dispositivo. Andare su "Utilit" e cliccare su "Reboot sistema".');
    }

    var el = getel(key);
    try {
    if (key == 'gw1.rad') {
        updateVar('gw1.pan', (value == '?')? '?' : value.substring(2,6));
        updateVar('gw1.epan', (value == '?')? '?' : value.substring(20,36));
        updateVar('gw1.chan', (value == '?')? '?' : h2d(value.substring(0,2)));
        return;
    }
    
    if (el) {
        var s = displayVal(key,value,el,1);
        fillElement(el,s);        
        
        el = getel(key + '_b');
        if (el) {
            s = displayVal(key,value,el,0);
            fillElement(el,s);
        }
    }
        if (key.match(/cn[1-9]\.alm/)) {
            var dev = key.substring(0,3);
            if ( varlist[dev+'.on'] * 1 )  value &= ~(1<<BIT_ALM_ONLINE); else value |= (1<<BIT_ALM_ONLINE);
            handleAlarms(key,value);
        }
    } catch(e) {
    }
}

function changeCounters(el) {
  var n = el.value;
  if (n != numcounters && confirm("Cambia numero contatori?")) {
    master.sendCmd('cfgnumcnt','param1='+n);
  } else {
    el.value = numcounters;
  }
}

function updateCounters() {
    var i, el;
    try {
      for (i=1; i<=MAX_COUNTERS; i++) {
        el = getel('statuscn'+i);
        if (el) el.style.display = (i<=numcounters)? 'block' : 'none';
        el = getel('cfgcn'+i);
        if (el) el.style.display = (i<=numcounters)? 'block' : 'none';        
        el = getel('histcn'+i);
        if (el) el.style.display = (i<=numcounters)? 'block' : 'none';        
      }
      el = getel('cfgnumcounters');
      el.value = numcounters;    
      getel('commandcnt').style.display = (numcounters == 1)? 'none' : '';    
      el = getel('idFLD_HISTCNT');
      el.length = 1 + numcounters;
      for (i=1; i<=numcounters; i++) el.options[i] = new Option("Contatore "+i,i);
      el = getel('utilitycnt');
      el.length = 2 + numcounters;
      for (i=1; i<=numcounters; i++) el.options[i+1] = new Option("Contatore "+i,i);
      el.value = (numcounters > 1)? -1 : 1;  
      el.disabled = (numcounters == 1)? 1 : 0;    
    } catch(e) {}
}

function updateStatus(arr) {
    for (var key in arr) varlist[key] = arr[key]; // store to the local buffer
    if ( arr['sys.numcnt']*1 ) {
        numcounters = arr['sys.numcnt']*1;
        updateCounters();
    }
    for (var key in arr) {
        if (key.match(/cn\d*/) 
            || key.indexOf('gw1.') == 0
            || key.indexOf('sys.') == 0) {
                updateVar(key,arr[key]);
            }
    }
    updateIP();
	updateAlarmPower();
}

function fmtSample(sam) {
    var obj;
    eval('obj = ' + sam);
    if (!obj || obj.time == 0) return '----';
    
    return displayVal('cn1.time', obj.time, null, true) + ", P=" + displayVal('cn1.ptot', obj.ptot, null, true) + ", E=" + displayVal('cn1.etot', obj.etot, null, true) + ", dBm=" + obj.dbm + ", Alarm=" + obj.alm;
   
}
function fmtSampleSet(sam) {
    var arr;
    eval('arr = ' + sam);
    if (!arr || arr.length == 0) return '----';
    var s = '';
    for (var i in arr) {
      var obj = arr[i];
      s += displayVal('cn1.time', obj.time, null, true) + ", P=" + displayVal('cn1.ptot', obj.ptot, null, true) + ", E=" + displayVal('cn1.etot', obj.etot, null, true) + ", dBm=" + obj.dbm + ", Alarm=" + obj.alm + "\n";
    }
    return s;
   
}


/**
 * Visualizza il risultato di un comando
 */
function showCmdResult(cmd,res) {
    var err = res.err;
    var msgok = "Comando eseguito correttamente.";
    
    if (verbose_result) {        
        verbose_result = false;
        updateStatus(res);
        if (err != 0) {
            alert("Errore nell'esecuzione del comando (" + res.err + ")");
        } else {
            alert(msgok);
        }        
        return;
    }
    
    var box = getel("resultbox");
    var s = "";
    if (err != 0) {
        box.className = 'resultbox1';
        s = "Errore nell'esecuzione del comando (" + res.err + ")\n";
        
        switch (cmd) {
            case 'register' :
            case 'sendtest' :
                if (res['sys.remerr']) {
                    s += "\n--------------------\n";
                    s += strip_html(res['sys.remerr']);
                }
                break;
        }
        
        box.value = s;        
        return;
    } else {
        box.className = 'resultbox0'; 
        s = msgok + "\n\n";
    }
        
    if (res['packet']) {
        s += "Pacchetto:\n" + res['packet'];
    }


    switch (cmd) {

        case 'reboot' :
            reboot_count = REBOOT_DELAY;
            rebooting();
            return;
            break;


        case 'ping' :
            s += res['result'].replace(/(\r\n|\n|\r)+/gm,"\n");
            break;

        case 'register' :
            if (err == 0) s += "Impianto registrato correttamente";
            break;

        case 'sendtest' :
            if (err == 0) {
                for (var i=1; i<=numcounters; i++) {
                    var v = 'cn'+i + '.async';
                    if (! res[v]) continue;
                    s += "Contatore " + i + " invio dati effettuato con successo.\n";
                    s += "Dati inviati:\n" + fmtSample(res[v]) + "\n\n";
                }
            }
            break;

        case 'async' :
            for (var i=1; i<=numcounters; i++) {
                var v = 'cn'+i + '.async';
                if (! res[v]) continue;
                s += "Lettura asincrona contatore " + i  + ":\n" + fmtSample(res[v]) + "\n\n";
            }
            break;
            
        case 'stat' :
            for (var i=1; i<=numcounters; i++) {
                var v = 'cn'+i + '.lstsam';
                if (! res[v]) continue;
                s += "*** Contatore " + i + "\nUltimo campione registrato:\n" + fmtSample(res[v]) + "\n\n";
                s += "Ultimi campioni spediti:\n" + fmtSampleSet(res['cn'+i+'.lstsnd']) + "\n";
                s += "Prossimi campioni da spedire:\n" + fmtSampleSet(res['cn'+i+'.nxtsnd']) + "\n";
            }
            break;
            
        default :
            updateStatus(res);
            break;
    }
    if (res['update']*1) updateStatus(res);

    box.value = s;
}

function setWait(f) {
  getel('waitdiv').style.display = f? 'block' : 'none';
}

function pollDevices(async) {
    setWait(true);
    getel("btstatus").disabled = true;
    setTimeout('pollDevices_tm()',10);    
}

function pollDevices_tm() {
    master.pollDevices();
    setWait(false);
    getel("btstatus").disabled = false;
}

var utf8map = [
"\u00e0","\\u00e0", 
"\u00e8","\\u00e8",
"\u00e9","\\u00e9",
"\u00ec","\\u00ec",
"\u00f9","\\u00f9",
"\u00f2","\\u00f2",
"\u00b0","\\u00b0"
];
// \u00e0\u00e8\u00e9\u00ec\u00f9\u00f2\u00b0

function UTF8encode(s) {
  var res = '';
  for (var i = 0; i < s.length; i++) {
    var c = s.charAt(i);
    var f = false;
    for (var j = 0; j < utf8map.length && !f; j+=2) {
        if (utf8map[j] == c) { res += utf8map[j+1]; f = true; }        
    }
    if (!f) res += c;    
  }
  return res;  
}

function UTF8decode(s) {
    if (s.indexOf('\\u') < 0) return s;
    for (var i = 0; i < utf8map.length; i+=2) s = s.replace( new RegExp('\\'+ utf8map[i+1],"g"), utf8map[i]);
    return s;
}


function extractStrerr(r) {
    var res = '';
    try {
        var a = eval('(' + r + ')');
        if (a.ERR*1 != 0) {
            res = 'ERR:' + a.ERR;
            res += ' ' + a.STRERR;        
        } else {
            var dati = a.DATI;
            for (var i=0; i<dati.length; i++) {
                var act = dati[i];
                if (act.ERR*1 != 0) {
                    res = 'ERR:' + act.ERR;
                    res += ' ' + act.STRERR;
                    break;
                }
            }            
        }
    } catch (e) {}
    return res;
}

/**
 * Oggetto JMaster
 */
function JMaster() {

    this.getURL = function() {
//        var el = getel('FLD_DIGIIP');
        var ip = '';
        if (ip == '') {
            var uri = parseUri(location.href);
            ip = uri.host;
  //          el.innerHTML = ip; //el.value = ip;
        } 
        return "http://" + ip + ((DIGI_PORT != 80)? ":" + DIGI_PORT : "") + "/comm4.php";     
        
    }

    this.parseResult = function(s) {
        var res = [];        
        res['err'] = 1;
        var r = s.split('&');
        for (var i = 0; i < r.length; i++) {
            var r2 = r[i].split('=');
            if (r2.length != 2) continue;
            res[ UTF8decode(unescape(r2[0])) ] = UTF8decode(unescape(r2[1]));
        }
        return res;
    }

    /* richiesta stato */
    this.pollDevices = function(async) {
        
        var url = this.getURL();
        var data = 'cmd=rdall';
        data = encodeURI(data);
                
        if (! async) {
          ajax_wr.httpRequest('POST',url,false,function() { },data);                
          if ( ajax_wr.isError() ) {
                alert('Errore durante la comunicazione col dispositivo');
          } else {          
                //jlog('V', 'pollDevices() ok: ' + ajax_wr.getText() ); // debug
                var res = this.parseResult(ajax_wr.getText());
                updateStatus(res);
          }
        } else {
          ajax_wr.httpRequest('POST',url,true,function() { ajaxCallbackAsync(); },data);                
        }
    }

    
    this.quickCmd2 = function(cmd, arg, opts) {
        var el = getel('utilitycnt');
        var cnt = el.value;
        if (cnt < 0) { alert('Scegliere prima un contatore'); return; }
        if ( opts && opts.confirm ) if (! confirm("Confermi comando?")) return false;
        if ( opts && opts.ask ) {
            var v = prompt(opts.ask);            
            if (v == null) return false;
            if (! v.match(/\d+/)) { alert('Valore non corretto'); return false; }
            arg = '' + v;            
        }
        getel("FLD_CNT").value = (cnt > 0)? cnt : '*';
        getel("FLD_CMD").value = cmd;
        getel("FLD_PAR").value = arg? arg : '';
        this.cmdClick();
        if (numcounters > 1) el.value = -1;
        return false;
    }


    
    this.quickCmd = function(cmd, arg, opts) {
        if ( opts && opts.confirm ) if (! confirm("Confermi comando?")) return false;
        if ( opts && opts.ask ) {
            var v = prompt(opts.ask);            
            if (v == null) return false;
            if (! v.match(/\d+/)) { alert('Valore non corretto'); return false; }
            arg = '' + v;            
        }
        var elcnt = getel("FLD_CNT"); 
        var elcmd = getel("FLD_CMD"); 
        var elpar = getel("FLD_PAR"); 
        elcnt.value = '';
        elcmd.value = cmd;
        elpar.value = (arg || (typeof(arg) == 'number'))? arg : '';
        this.cmdClick();
        if (opts && opts.quiet) {
            elcnt.value = elcmd.value = elpar.value = '';
        }
        return false;
    }
    
    this.mod_etot = function() {
        var v = Math.floor(getel("cn1.etot_b").value * 1 * SCALE_KW) / SCALE_KW;
        if (confirm("Si sta tentando di modificare il contatore energetico scrivendo il valore " + v + ", vuoi continuare?")) {
            if (v < 0) {alert("Valore non corretto"); return; }
            verbose_result = true;
            this.quickCmd( 'setecount', v, {"quiet":1});        
        }
    }
    
    
    /* invio di un comando diretto */
    this.sendCmd = function(cmd, args) {  
        getel('resultbox').value = '';
        var url = this.getURL();
        var data = 'cmd=' + cmd;       
        if (args) data += '&' + args;        
        data = encodeURI(data);        
        ajax_wr.httpRequest('POST',url,false,function () {},data);                
        ajaxCallbackSync();
        //getel('MEM_CONSOLE').value = 'Result: ' + ajax_wr.request.responseText + "\n";
        if ( ajax_wr.isError() ) {
            alert('Errore durante la comunicazione col dispositivo');
        } else {
            var res = this.parseResult(ajax_wr.getText());
            showCmdResult(cmd, res);
        }
    }


    /* click su invia comando */
    this.cmdClick = function() {
        var cmd = getel("FLD_CMD").value;
        var arg = getel("FLD_PAR").value;
        var cnt = getel("FLD_CNT").value;        
        if (cnt == '*') cnt = '0';
        if (arg != '') arg = 'param1=' + arg;
        if (cnt != '') arg += ((arg!='')? '&' : '' ) + 'cnt='+cnt;
        this.sendCmd(cmd, arg);
        return false;
    }


    /* click su voce di menu */
    this.mnClick = function(id) {
        getel('pan_' + idmenu).style.display = 'none';
        getel('pan_' + id).style.display = 'block';
        idmenu = id;    
        if (id == 'status') {
            pollDevices();
        }
    }


    /* click su salva rete */
    this.saveNet = function() {
        try {                        
            var data, tmp;
            data = "cmd=cfgnet";
            var dhcp = getel('pdhcp0').checked? 0 : 1;
            var ip = getIP('sys.ip');
            var mask = getIP('sys.mask');
            var gway = getIP('sys.gway');
            var dns = getIP('sys.dns');
            if (!dhcp &&  ( ! validIP(ip) || ! validIP(mask,true)
                || !validIP(gway) || !validIP(dns) )) {
                alert('Parametri rete non corretti');
                return;

            }
            var ntp = jtrim( getel('sys.ntpsrv').value );
            
            data += "&dhcp="  + dhcp;
            data += "&ip="  + encodeURI(ip);
            data += "&mask="  + encodeURI(mask);
            data += "&gway="  + encodeURI(gway);
            data += "&dns="  + encodeURI(dns);
            data += "&ntpsrv="  + encodeURI(ntp);
            
            //alert(data);
            //data = encodeURI(data);            
            ajax_wr.httpRequest('POST',this.getURL(),false,function() { },data);                
            if ( ajax_wr.isError() ) {
                alert('Errore durante la comunicazione col dispositivo');
            } else {
                var res = this.parseResult(ajax_wr.getText());
                if (res.err == 0) {
                    updateStatus(res);
                    alert('Configurazione di rete salvata correttamente. ATTENZIONE: IL DISPOSITIVO VERRA\' RIAVVIATO.');
                } else {
                    var r = extractStrerr(res['sys.remerr']);
                    alert('Errore durante il salvataggio dei parametri. ' + r);
                }
            }         
        } catch(e) {
        }
    }

    /* click su salva configurazione */
    this.saveConfig = function(fregister) {
        try {                        
            var isregistered = varlist['sys.regist'] == 1;
            var data, tmp;
            if (fregister) {
                data = "cmd=register";
                var srvurl = getel('sys.srvurl').value;
                var nimp   = jtrim(getel('sys.nimp').value);
                var indir  = jtrim(getel('sys.indir').value);
                //var cuser  = jtrim(getel('sys.cuser').value);
                //var cpass  = jtrim(getel('sys.cpass').value);
                //var cpass2  = jtrim(getel('sys.cpass2').value);
                //if (cpass != cpass2) { alert('Le due password non coincidono'); return; }
                var cmail  = jtrim(getel('sys.cmail').value);
                //var codins = jtrim(getel('sys.codins').value);
                var re = /^[A-Z0-9a-z ^'*+;:_()\[\]@\.\-\u00e0\u00e8\u00e9\u00ec\u00f9\u00f2\u00b0\/,#]{0,32}$/;
                if (! nimp.match(re)) { alert('Nome impianto con caratteri non validi'); return; }
                if (! indir.match(re)) { alert('Indirizzo con caratteri non validi'); return; }
                nimp  = UTF8encode(nimp);
                indir = UTF8encode(indir);
                //if (! codins.match(/^[A-Z0-9a-z \.\-_]*$/)) { alert('Codice installatore con caratteri non validi'); return; }
                //if (! cuser.match(/^[A-Z0-9a-z]{4,16}$/)) { alert('Utente con caratteri non validi, o troppo corto'); return; }            
                //if ((fregister && cpass.length == 0) || ! cpass.match(/^[A-Z0-9a-z]{0,16}$/)) { alert('Password con caratteri non validi o troppo corta'); return; }            
                if (! cmail.match(/^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})$/)) { alert('Email non valida'); return; }
                data += "&srvurl="  + encodeURI(srvurl);
                data += "&nimp="   + encodeURI(nimp);
                data += "&indir="  + encodeURI(indir);
                //data += "&cuser="  + encodeURI(cuser);
                //data += "&cpass="  + encodeURI(cpass);
                data += "&cmail="  + encodeURI(cmail);
                //data += "&codins=" + encodeURI(codins);
                //if (fregister) data += "&register=1";
            } else {
                data = "cmd=cfg";
                var prezzo = getel('sys.prezzo_b').value * 1;
                var co2 = getel('sys.co2_b').value * 1;
                prezzo = Math.floor(prezzo * 1000);
                co2 = Math.floor(co2 * 1000);
                if (prezzo < 0) { alert('Prezzo non valido'); return; }
                if (co2 < 0) { alert('Equivalenza CO2 non valida'); return; }
                data += "&prezzo=" + prezzo;
                data += "&co2=" + co2;
				if (getel('sys.alrpwr_b').checked == false) {
					data += "&alrpwr=0";
				} else {
					data += "&alrpwr=1";
				}
                for (var i = 1; i <= numcounters; i++) {
                    var dev = 'cn'+i;
                    var s = 'Contatore ' + i;
                    var whi  = getel(dev + '.whi_b').value*1;
                    var pnom = Math.floor(getel(dev+'.pnom_b').value*1);
                    var pmin = Math.floor(getel(dev+'.pmin').value*1);                
                    tmp = Math.floor(pnom);
                    if (tmp > MAX_PNOM || tmp < MIN_PNOM) { alert(s+': potenza nominale non valida'); return; }
                    tmp = Math.floor(whi*SCALE_WHI);
                    if (tmp > MAX_WHI || tmp < MIN_WHI) { alert(s + ': watt/ora per impulso non valido'); return; }
                    var pmin_min = Math.ceil( (3600 / 256) * whi );
                    if (pmin != 0 && pmin <= pmin_min) {
                        alert(s + ': soglia potenza minima non valida');
                        return;
                    }                            
                    if (pnom > PNOM_SHIFT) {
                        if ( ((whi * 10) % 10) != 0 ) { alert('Errore: il Wh/Impulso deve essere intero'); return; }
                        if ( (pnom % 10) != 0 ) { alert('Errore: la potenza nominale deve essere multiplo di 10'); return; }
                        if ( (pmin % 10) != 0 ) { alert('Errore: la soglia potenza minima deve essere multiplo di 10'); return; }
                    }                
                    data += "&whi" + i + "=" + encodeURI(whi);
                    data += "&pnom" + i + "=" + encodeURI(pnom);
                    data += "&pmin" + i + "=" + encodeURI(pmin);
                }
            }                                
            //data = encodeURI(data);            
            ajax_wr.httpRequest('POST',this.getURL(),false,function() { },data);                
            if ( ajax_wr.isError() ) {
                alert('Errore durante la comunicazione col dispositivo');
            } else {
                var res = this.parseResult(ajax_wr.getText());
                if (res.err == 0) {
                    updateStatus(res);
                    alert(fregister? 'Impianto registrato correttamente' : 'Configurazione salvata correttamente');
                } else {
                    var r = extractStrerr(res['sys.remerr']);
                    alert('Errore durante il salvataggio dei parametri. ' + r);
                }
            }         
        } catch(e) {
        }
    }
    
    this.showRemerr = function() {
        var box = getel("resultbox");
        box.className = 'resultbox0';
        var s = 'ULTIMO MESSAGGIO SERVER:\n\n';
        box.value = s + varlist['sys.remerr'];
    }
    
    

}

function qreboot() { try { master.quickCmd('reboot'); window.scrollTo(0,0); } catch(e) {}; return false; }

function cmdCallback(cmd,err) {
    err *= 1;
    switch (cmd) {
        case 'firmware' :
            var el = getel('firmware_result');
            if (err) {
                el.innerHTML = "Si  verificato un errore nel salvataggio dell'aggiornamento";
                el.className = 'msgerr';
            } else {
                el.innerHTML = "Aggiornamento trasferito, per installarlo riavviare il dispositivo (<a href=\"#\" onClick=\"return qreboot()\">clicca qui per riavviare</a>)";
                el.className = 'msgok';            
            }
            break;
            
        case 'putconf' :
            if (err) {
                alert('Si  verificato un errore nel salvataggio della configurazione');
            } else {
                alert('Configurazione salvata correttamente');
                getel("uploadconfigbox").style.display = 'none';
            }
            pollDevices(false);
            break;
    }

}


/**
 * Function: ajaxCallbackSync()
 * Description: Synchronous ajax callback
 */
function ajaxCallbackSync() {
    var err = 1;
    var req = ajax_wr.request;
    if ( req.readyState == 4 ) {
        // communication ended
        //quickSwitch("www1.poll", 0);        
        
        if ( req.status == 200 ) {
            // everything ok from web server
            jlog('V', 'Sync comm ok: ' + req.responseText );
//            master.parseResult(req.responseText);
        } else {
            jlog('V', 'Sync status error: ' + req.status );
        }
    } else {
        //jlog('V', 'Sync request error: ' + req.readyState );
    }
    return err;
}

/**
 * Function: ajaxCallbackSync()
 * Description: Asynchronous ajax callback
 */
function ajaxCallbackAsync() {
    var req = ajax_poll.request;
    if ( req.readyState == 4 ) {
        // communication ended
        if ( req.status == 200 ) {
            // everything ok from web server
            jlog('V', 'Async comm ok: ' + req.responseText );
        } else {
            jlog('V', 'ASync status error: ' + req.status );
        }
    } else {
        //jlog('V', 'ASync request error: ' + req.readyState );
    }
}

function details(el) {
  var el = getel(el);
  if (el) if (el.style.display == 'block') el.style.display = 'none'; else el.style.display = 'block';
  return false;
}
